package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.CustomerPayBack;
import com.ff.weijinxiao.repository.CustomerPayBackRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class CustomerPayBackService {

    @Resource
    private CustomerPayBackRepository customerPayBackRepository;

    /**
     * 创建实体
     *
     * @param customerPayBack
     */
    public CustomerPayBack saveCustomerPayBack(CustomerPayBack customerPayBack) {
        return customerPayBackRepository.save(customerPayBack);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public CustomerPayBack findById(Integer id) {
        Optional<CustomerPayBack> optional = customerPayBackRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public CustomerPayBack findByOnlyID(String onlyID) {
        return customerPayBackRepository.findByOnlyID(onlyID);
    }

    public void deleteById(Integer id) {
        customerPayBackRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<CustomerPayBack> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return customerPayBackRepository.findAll(SpecificationUtil.buildSpecification(param, CustomerPayBack.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<CustomerPayBack> findList(Map<String, Object> param) {
        return customerPayBackRepository.findAll(SpecificationUtil.buildSpecification(param, CustomerPayBack.class));
    }


}
